static char rcsver[] = "$Id: dir.c,v 1.1 2000/09/13 19:34:31 saadat Exp $";
 
/**
 ** $Source: /tes/cvs/Vcol/dir.c,v $
 **
 ** $Log: dir.c,v $
 ** Revision 1.1  2000/09/13 19:34:31  saadat
 ** This version was built some time back but never got checked in. I
 ** accidently updated it from the cvs repository and then removed the
 ** changes made by cvs. It is now in working condition again.
 **
 ** Some additional format checks have been built into this version,
 ** including:
 ** 	- Field length check
 ** 	- Overlap between fields
 ** 	- Field count
 **
 ** Revision 1.1  1999/10/25 19:20:52  saadat
 ** Major updates to Vmerge structure. Various functions have been scattered
 ** into different files instead of cluttering everything together in merge.c
 **
 ** The new version of Vmerge, i.e. 1.2 supports only merging between the
 ** following:
 **   a) atomic field -> atomic field
 ** 	  atomic fields include the bit fields as well as the byte offset
 ** 	  fields.
 **   b) fixed array[i-j] -> fixed array[l-m] where |m-l| == |j-i|
 **   c) open ended vardata array[] -> open ended vardata array[]
 **
 ** Revision 2.1  1999/02/10 04:00:50  gorelick
 ** *** empty log message ***
 **
 ** Revision 2.0  1998/12/22 22:47:04  gorelick
 ** release version
 **
 ** Revision 2.0  1998/12/18 01:26:03  gorelick
 ** release version
 **
 ** Revision 1.3  1998/12/18 01:04:48  gorelick
 ** *** empty log message ***
 **
 ** Revision 1.2  1998/11/12 22:58:55  gorelick
 ** first release version
 **
 **/

#include <dirent.h>
#include <string.h>
#include "tools.h"

#define qsortptr int (*)(const void *, const void *)

int mystrcmp(const char **a, const char **b);

/**
 ** Given a directory and table prefix, load the name of all the files
 **/

LIST *
LoadFilenames(char *path, char *prefix)
{
    DIR *d;
    LIST *list;
    struct dirent *d_ent;
    char buf[256];
	int i;

    if ((d = opendir(path)) == NULL)
        return (NULL);

    list = new_list();
    while ((d_ent = readdir(d)) != NULL) {
        if (IsDataFile(d_ent->d_name, prefix)) {
            /**
            ** Store the filename
            **/
            sprintf(buf, "%s/%s", path, d_ent->d_name);
            list_add(list, strdup(buf));
        }
    }
    closedir(d);

    SortFiles(list);
    return(list);
}

IsDataFile(char *test, char *type)
{
    char *p;
    if (!strncasecmp(test, type, strlen(type))) {
        p = strrchr(test, '.');
        if (p && (!strcasecmp(p, ".DAT") || !strcasecmp(p, ".TAB")))
            return (1);
    }
    return (0);
}

int
mystrcmp(const char **a, const char **b)
{
	return(strcmp(*a, *b));
}

SortFiles(LIST *list)
{
	int i;

    if (list->number > 1)
        qsort(list->ptr, list->number, sizeof(char *), (qsortptr)mystrcmp);
}
