/*
 * A quick and easy way to determine the endian-ness of a machine.
 * Useful for incorporating into programs for which this matters.
 *
 * I found this code in the public domain and so it remains.
 * 
 */

#include <stdio.h>

void endian_test()
{
    short s = 1;
    short *ptr = &s;
    unsigned char c = *((char *) ptr);

    switch (c) {
    case 0:
#ifdef _LITTLE_ENDIAN
	fprintf(stderr, "compile error: compiled with _LITTLE_ENDIAN\n");
	exit(1);
#else
	return;
#endif
        break;
    case 1:
#ifdef _LITTLE_ENDIAN
	return;
#else
	fprintf(stderr, "compile error: not compiled with _LITTLE_ENDIAN\n");
	exit(1);
#endif
        break;
    default:
        printf("unknown-endian\n");
        break;
    }
}
