#define _XLATE_C_
/**
 ** Translation matrices
 **/

#include <stddef.h>
#include <string.h>
#include "gdrbyteconv.h"
#include "xlate.h"
#include "globals.h"

/*
typedef struct {
  FIELD *field;
  int    var_data_flag;
  union {
    int    index;
    IRANGE bit_range;
  } index_info;
  int    start_byte_in_rec;
  struct {
    int    shift;
    int    mask;
  } bit_field_stuff;
} XFIELD;

typedef struct {
  int truncation;
} I2EWarnings;

*/

int Int2MsbInt(DATA input_data, char *output_field, int output_field_size,
               I2EScalingInfo *, I2EMiscCnvInfo *);
int Int2MsbUInt(DATA input_data, char *output_field, int output_field_size,
                I2EScalingInfo *, I2EMiscCnvInfo *);
int Int2IeeeReal(DATA input_data, char *output_field, int output_field_size,
                 I2EScalingInfo *, I2EMiscCnvInfo *);
int Int2AsciiInt(DATA input_data, char *output_field, int output_field_size,
                 I2EScalingInfo *, I2EMiscCnvInfo *);
int Int2AsciiReal(DATA input_data, char *output_field, int output_field_size,
                  I2EScalingInfo *, I2EMiscCnvInfo *);
int Int2ByteOffset(DATA input_data, char *output_field, int output_field_size,
                   I2EScalingInfo *, I2EMiscCnvInfo *);
int Int2MsbBitField(DATA input_data, char *output_field, int output_field_size,
                    I2EScalingInfo *, I2EMiscCnvInfo *misc_info);
int UInt2MsbInt(DATA input_data, char *output_field, int output_field_size,
                I2EScalingInfo *, I2EMiscCnvInfo *);
int UInt2MsbUInt(DATA input_data, char *output_field, int output_field_size,
                 I2EScalingInfo *, I2EMiscCnvInfo *);
int UInt2IeeeReal(DATA input_data, char *output_field, int output_field_size,
                  I2EScalingInfo *, I2EMiscCnvInfo *);
int UInt2AsciiInt(DATA input_data, char *output_field, int output_field_size,
                  I2EScalingInfo *, I2EMiscCnvInfo *);
int UInt2AsciiReal(DATA input_data, char *output_field, int output_field_size,
                   I2EScalingInfo *, I2EMiscCnvInfo *);
int UInt2MsbBitField(DATA input_data, char *output_field, int output_field_size,
                     I2EScalingInfo *, I2EMiscCnvInfo *misc_info);
int Real2IeeeReal(DATA input_data, char *output_field, int output_field_size,
                  I2EScalingInfo *, I2EMiscCnvInfo *);
int Real2MsbInt(DATA input_data, char *output_field, int output_field_size,
                I2EScalingInfo *, I2EMiscCnvInfo *);
int Real2MsbUInt(DATA input_data, char *output_field, int output_field_size,
                 I2EScalingInfo *, I2EMiscCnvInfo *);
int Real2AsciiInt(DATA input_data, char *output_field, int output_field_size,
                  I2EScalingInfo *, I2EMiscCnvInfo *);
int Real2AsciiReal(DATA input_data, char *output_field, int output_field_size,
                   I2EScalingInfo *, I2EMiscCnvInfo *);
int Str2Str(DATA input_data, char *output_field, int output_field_size,
            I2EScalingInfo *, I2EMiscCnvInfo *misc_info);

/* For mapping, see the format definitions in header.h */
I2EFuncPtr I2E[MAX_IFORMATS+1][MAX_EFORMATS+1] = {
  { NULL, NULL,     NULL,         NULL,          NULL,          NULL,          NULL,           NULL,           NULL             }, 
  { NULL, NULL,     Int2MsbInt,   Int2MsbUInt,   Int2IeeeReal,  Int2AsciiInt,  Int2AsciiReal,  Int2ByteOffset, Int2MsbBitField  },
  { NULL, NULL,     UInt2MsbInt,  UInt2MsbUInt,  UInt2IeeeReal, UInt2AsciiInt, UInt2AsciiReal, NULL,           UInt2MsbBitField },
  { NULL, NULL,     Real2MsbInt,  Real2MsbUInt,  Real2IeeeReal, Real2AsciiInt, Real2AsciiReal, NULL,           NULL             },
  { NULL, Str2Str,  NULL,         NULL,          NULL,          NULL,          NULL,           NULL,           NULL             }
};


/* Note that input and output data types are implicit in the function being called
   Also note that I2EScalingInfo is being ignored right now */
int
Int2MsbInt(DATA input_data,
           char *output_field, int output_field_size,
           I2EScalingInfo *scaling_info_ignored,
           I2EMiscCnvInfo *misc_info_ignored)
{
  char   c;
  short  s;

  switch(output_field_size){
  case sizeof(char):  c = (char)input_data.i; *output_field = c; break;
  case sizeof(short): s = (short)input_data.i; I16_TO_C16(output_field, s); break;
  case sizeof(int):   I32_TO_C32(output_field, input_data.i); break;
  default:
    fprintf(stderr, "%s: Conversion from Int -> MsbInt(%d) unsupported.\n",
            pgm_name, output_field_size);
    abort();
  }
  return 1;
}

int
Int2MsbUInt(DATA input_data,
            char *output_field, int output_field_size,
            I2EScalingInfo *scaling_info_ignored,
            I2EMiscCnvInfo *misc_info_ignored)
{
  uchar c;
  ushort s;
  uint i;

  switch(output_field_size){
  case sizeof(char):  c = (uchar)input_data.i; *(uchar *)output_field = c; break;
  case sizeof(short): s = (ushort)input_data.i; U16_TO_C16(output_field, s); break;
  case sizeof(int):   i = (uint)input_data.i; U32_TO_C32(output_field, i); break;
  default:
    fprintf(stderr, "%s: Conversion from Int -> MsbUInt(%d) unsupported.\n",
            pgm_name, output_field_size);
    abort();
  }
  return 1;
}

int
Int2IeeeReal(DATA input_data,
             char *output_field, int output_field_size,
             I2EScalingInfo *scaling_info_ignored,
             I2EMiscCnvInfo *misc_info_ignored)
{
  float  f;
  double d;

  switch(output_field_size){
  case sizeof(float): f = (float)input_data.i; F32_TO_C32(output_field, f); break;
  case sizeof(double): d = (double)input_data.i; F64_TO_C64(output_field, d); break;
  default:
    fprintf(stderr, "%s: Conversion from Int -> IeeeReal(%d) unsupported.\n",
            pgm_name, output_field_size);
    abort();
    break;
  }
  return 1;
}

int
Int2AsciiInt(DATA input_data,
             char *output_field, int output_field_size,
             I2EScalingInfo *scaling_info_ignored,
             I2EMiscCnvInfo *misc_info_ignored)
{
  char buff[128];
  int actual_size;

  actual_size = snprintf(buff, output_field_size + 1, "%-*d", output_field_size, input_data.i);
  memcpy(output_field, buff, strlen(buff));
  
  if (strlen(buff) != actual_size){ return 0; } /* Truncation has occurred */
  return 1;
}

int
Int2AsciiReal(DATA input_data,
              char *output_field, int output_field_size,
              I2EScalingInfo *scaling_info_ignored,
              I2EMiscCnvInfo *misc_info_ignored)
{
  char buff[1024];
  int actual_size;
  double d;

  d = (double)input_data.i;
  actual_size = snprintf(buff, output_field_size + 1, "%-*f", output_field_size, d);
  memcpy(output_field, buff, strlen(buff));

  if (strlen(buff) != actual_size){ return 0; } /* Truncation has occurred */
  return 1;
}

int
Int2ByteOffset(DATA input_data,
               char *output_field, int output_field_size,
               I2EScalingInfo *scaling_info_ignored,
               I2EMiscCnvInfo *misc_info_ignored)
{
  I32_TO_C32(output_field, input_data.i);
  return 1;
}


int
Int2MsbBitField(DATA input_data,
                char *output_field, int output_field_size,
                I2EScalingInfo *scaling_info_ignored,
                I2EMiscCnvInfo *misc_info)
{
  int   shift;
  uint  mask;
  char  c, oc;
  short s, os;
  int   oi;
  
  if (misc_info == NULL){
    fprintf(stderr, "%s: misc_info must be supplied for Int -> MsbBitField conversion.\n",
            pgm_name);
    abort();
  }

  shift = misc_info->bitfield.shift;
  mask = misc_info->bitfield.mask;
  
  switch(output_field_size){
  case sizeof(char):
    c = (char)input_data.i;
    memcpy(&oc, output_field, sizeof(char));
    oc &= ~((uchar)mask << shift);
    oc |= (c << shift) & ((uchar)mask << shift);
    memcpy(output_field, &oc, sizeof(char));
    break;

  case sizeof(short):
    s = (short)input_data.i;
    memcpy(&os, output_field, sizeof(short));
    os &= ~((ushort)mask << shift);
    os |= (s << shift) & ((ushort)mask << shift);
    memcpy(output_field, &os, sizeof(short));
    break;

  case sizeof(int):
    memcpy(&oi, output_field, sizeof(int));
    oi &= ~(mask << shift);
    oi |= (input_data.i << shift) & (mask << shift);
    memcpy(output_field, &oi, sizeof(int));
    break;

  default:
    fprintf(stderr, "%s: Conversion from Int -> MsbBitField(%d) not supported.\n",
            pgm_name, output_field_size);
    abort();
  }
  return 1;
}

int
UInt2MsbInt(DATA input_data,
            char *output_field, int output_field_size,
            I2EScalingInfo *scaling_info_ignored,
            I2EMiscCnvInfo *misc_info_ignored)
{
  char   c;
  short  s;
  int    i;

  switch(output_field_size){
  case sizeof(char): c = (char)input_data.ui; *output_field = c; break;
  case sizeof(short): s = (short)input_data.ui; U16_TO_C16(output_field, s); break;
  case sizeof(int): i = (int)input_data.ui; U32_TO_C32(output_field, i); break;
  default:
    fprintf(stderr, "%s: Conversion from UInt -> MsbInt(%d) unsupported.\n",
            pgm_name, output_field_size);
    abort();
  }
}

int
UInt2MsbUInt(DATA input_data,
             char *output_field, int output_field_size,
             I2EScalingInfo *scaling_info_ignored,
             I2EMiscCnvInfo *misc_info_ignored)
{
  uchar   c;
  ushort  s;

  switch(output_field_size){
  case sizeof(uchar): c = (uchar)input_data.ui; *output_field = c; break;
  case sizeof(ushort): s = (ushort)input_data.ui; I16_TO_C16(output_field, s); break;
  case sizeof(uint): I32_TO_C32(output_field, input_data.ui); break;
  default:
    fprintf(stderr, "%s: Conversion from UInt -> MsbUInt(%d) unsupported.\n",
            pgm_name, output_field_size);
    abort();
  }
}

int
UInt2IeeeReal(DATA input_data,
              char *output_field, int output_field_size,
              I2EScalingInfo *scaling_info_ignored,
              I2EMiscCnvInfo *misc_info_ignored)
{
  float  f;
  double d;

  switch(output_field_size){
  case sizeof(float): f = (float)input_data.ui; F32_TO_C32(output_field, f); break;
  case sizeof(double): d = (double)input_data.ui; F64_TO_C64(output_field, d); break;
  default:
    fprintf(stderr, "%s: Conversion from UInt -> IeeeReal(%d) unsupported.\n",
            pgm_name, output_field_size);
    abort();
  }
  return 1;
}

int
UInt2AsciiInt(DATA input_data,
              char *output_field, int output_field_size,
              I2EScalingInfo *scaling_info_ignored,
              I2EMiscCnvInfo *misc_info_ignored)
{
  char buff[128];
  int actual_size;

  actual_size = snprintf(buff, output_field_size + 1, "%-*u", output_field_size, input_data.ui);
  memcpy(output_field, buff, strlen(buff));
  
  if (strlen(buff) != actual_size){ return 0; } /* Truncation has occurred */
  return 1;
}

int
UInt2AsciiReal(DATA input_data,
             char *output_field, int output_field_size,
             I2EScalingInfo *scaling_info_ignored,
             I2EMiscCnvInfo *misc_info_ignored)
{
  char   buff[1024];
  int    actual_size;
  double d;

  d = (double)input_data.ui;
  actual_size = snprintf(buff, output_field_size + 1, "%-*f", output_field_size, d);
  memcpy(output_field, buff, strlen(buff));
  
  if (strlen(buff) != actual_size){ return 0; } /* Truncation has occurred */
  return 1;
}

int
UInt2MsbBitField(DATA input_data,
             char *output_field, int output_field_size,
             I2EScalingInfo *scaling_info_ignored,
             I2EMiscCnvInfo *misc_info)
{
  int    shift;
  uint   mask;
  uchar  c, oc;
  ushort s, os;
  uint   oi;
  
  if (misc_info == NULL){
    fprintf(stderr, "%s: misc_info must be supplied for UInt -> MsbBitField conversion.\n",
            pgm_name);
    abort();
  }

  shift = misc_info->bitfield.shift;
  mask = misc_info->bitfield.mask;
  
  switch(output_field_size){
  case sizeof(char):
    c = (uchar)input_data.ui;
    memcpy(&oc, output_field, sizeof(uchar));
    oc &= ~((uchar)mask << shift);
    oc |= (c << shift) & ((uchar)mask << shift);
    memcpy(output_field, &oc, sizeof(uchar));
    break;

  case sizeof(short):
    s = (ushort)input_data.ui;
    memcpy(&os, output_field, sizeof(ushort));
    os &= ~((ushort)mask << shift);
    os |= (s << shift) & ((ushort)mask << shift);
    memcpy(output_field, &os, sizeof(ushort));
    break;

  case sizeof(int):
    memcpy(&oi, output_field, sizeof(uint));
    oi &= ~(mask << shift);
    oi |= (input_data.ui << shift) & (mask << shift);
    memcpy(output_field, &oi, sizeof(uint));
    break;

  default:
    fprintf(stderr, "%s: Conversion from UInt -> MsbBitField(%d) not supported.\n",
            pgm_name, output_field_size);
    abort();
  }
  return 1;
}


int
Real2IeeeReal(DATA input_data,
              char *output_field, int output_field_size,
              I2EScalingInfo *scaling_info_ignored,
              I2EMiscCnvInfo *misc_info_ignored)
{
  float f;

  switch(output_field_size){
  case sizeof(float):
    f = (float)input_data.r;
    F32_TO_C32(output_field, f);
    break;

  case sizeof(double):
    F64_TO_C64(output_field, input_data.r);
    break;

  default:
    fprintf(stderr, "%s: Conversion from Real -> IeeeReal(%d) not supported.\n",
            pgm_name, output_field_size);
    abort();
  }
  return 1;
}

int
Real2MsbInt(DATA input_data, char *output_field, int output_field_size,
            I2EScalingInfo *scaling_info_ignored, I2EMiscCnvInfo *misc_info_ignored)
{
  int i;
  short s;
  char c;

  switch(output_field_size){
  case sizeof(char):
    c = (char)(input_data.r + 0.5);
    memcpy(output_field, &c, sizeof(char));
    break;
    
  case sizeof(short):
    s = (short)(input_data.r + 0.5);
    I16_TO_C16(output_field, s);
    break;
    
  case sizeof(int):
    i = (int)(input_data.r + 0.5);
    I32_TO_C32(output_field, i);
    break;

  default:
    fprintf(stderr, "%s: Conversion from Real -> MsbInt(%d) not supported.\n",
            pgm_name, output_field_size);
    abort();
  }

  return 1;
}

int
Real2MsbUInt(DATA input_data, char *output_field, int output_field_size,
             I2EScalingInfo *scaling_info_ignored, I2EMiscCnvInfo *misc_info_ignored)
{
  uint i;
  ushort s;
  uchar c;

  switch(output_field_size){
  case sizeof(char):
    c = (uchar)(input_data.r + 0.5);
    memcpy(output_field, &c, sizeof(uchar));
    break;
    
  case sizeof(short):
    s = (ushort)(input_data.r + 0.5);
    I16_TO_C16(output_field, s);
    break;
    
  case sizeof(int):
    i = (uint)(input_data.r + 0.5);
    I32_TO_C32(output_field, i);
    break;

  default:
    fprintf(stderr, "%s: Conversion from Real -> MsbUInt(%d) not supported.\n",
            pgm_name, output_field_size);
    abort();
  }

  return 1;
}

int
Real2AsciiInt(DATA input_data, char *output_field, int output_field_size,
              I2EScalingInfo *scaling_info_ignored, I2EMiscCnvInfo *misc_info_ignored)
{
  char   buff[1024];
  int    actual_size;
  
  actual_size = snprintf(buff, output_field_size + 1, "%-*d", output_field_size, (int)(input_data.r + 0.5));
  memcpy(output_field, buff, strlen(buff));
  
  if (strlen(buff) != actual_size){ return 0; } /* Truncation has occurred */
  return 1;
}

int
Real2AsciiReal(DATA input_data,
               char *output_field, int output_field_size,
               I2EScalingInfo *scaling_info_ignored,
               I2EMiscCnvInfo *misc_info_ignored)
{
  char   buff[1024];
  int    actual_size;
  double d;

  actual_size = snprintf(buff, output_field_size + 1, "%-*f", output_field_size, input_data.r);
  memcpy(output_field, buff, strlen(buff));
  
  if (strlen(buff) != actual_size){ return 0; } /* Truncation has occurred */
  return 1;
}

int
Str2Str(DATA input_data,
        char *output_field, int output_field_size,
        I2EScalingInfo *scaling_info_ignored,
        I2EMiscCnvInfo *misc_info)
{
  int input_field_size;
  int min_size;

  if (misc_info == NULL){
    input_field_size = output_field_size; /* This could, however, mean data truncation */
  }
  else {
    input_field_size = misc_info->string.input_field_size;
  }
  
  /* Select the smaller of the sizes */
  min_size = input_field_size < output_field_size ? input_field_size : output_field_size;

  /* Copy data to the output field */
  memcpy(output_field, input_data.str, min_size);
  if (output_field_size > input_field_size){
    /* Space pad the output field, if it is larger than the input field */
    memset(output_field + input_field_size, ' ', output_field_size - input_field_size);
    return 0;
  }
  else if (output_field_size < input_field_size){
    return 0;
  }

  return 1;
}
